
;CodeVisionAVR C Compiler V3.14 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega64
;Program type           : Application
;Clock frequency        : 1.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega64
	#pragma AVRPART MEMORY PROG_FLASH 65536
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x10FF
	.EQU __DSTACK_SIZE=0x0400
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	CALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _l=R4
	.DEF _l_msb=R5
	.DEF _l1=R6
	.DEF _l1_msb=R7
	.DEF _l3=R8
	.DEF _l3_msb=R9
	.DEF _kelid=R10
	.DEF _kelid_msb=R11
	.DEF _round=R12
	.DEF _round_msb=R13

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x14,0x0
	.DB  0x1,0x0

_0x3:
	.DB  0x6,0x0,0x5B
_0x4:
	.DB  0x0,0x0,0x1,0x0,0x2,0x0,0x3,0x0
	.DB  0x4,0x0,0x5,0x0,0x6,0x0,0x7,0x0
	.DB  0x8
_0x0:
	.DB  0x58,0x0,0x4F,0x0,0x20,0x0,0x25,0x64
	.DB  0x0,0x57,0x65,0x6C,0x6C,0x63,0x6F,0x6D
	.DB  0x65,0x20,0x74,0x6F,0x0,0x58,0x4F,0x20
	.DB  0x67,0x61,0x6D,0x65,0x21,0x0,0x74,0x6F
	.DB  0x20,0x73,0x74,0x61,0x72,0x74,0x20,0x70
	.DB  0x72,0x65,0x73,0x73,0x0,0x61,0x6E,0x79
	.DB  0x20,0x6B,0x65,0x79,0x0,0x72,0x6F,0x75
	.DB  0x6E,0x64,0x3D,0x25,0x64,0x0,0x58,0x5F
	.DB  0x57,0x49,0x4E,0x3D,0x25,0x64,0x0,0x4F
	.DB  0x5F,0x57,0x49,0x4E,0x3D,0x25,0x64,0x0
	.DB  0x58,0x20,0x74,0x75,0x72,0x6E,0x0,0x4F
	.DB  0x20,0x74,0x75,0x72,0x6E,0x0,0x58,0x20
	.DB  0x77,0x69,0x6E,0x0,0x4F,0x20,0x77,0x69
	.DB  0x6E,0x0,0x31,0x3D,0x70,0x6C,0x79,0x20
	.DB  0x61,0x67,0x69,0x6E,0x0,0x32,0x3D,0x45
	.DB  0x58,0x49,0x54,0x0,0x64,0x72,0x61,0x77
	.DB  0x21,0x0,0x63,0x6F,0x6E,0x67,0x72,0x61
	.DB  0x74,0x75,0x6C,0x61,0x74,0x69,0x6F,0x6E
	.DB  0x20,0x6F,0x0,0x63,0x6F,0x6E,0x67,0x72
	.DB  0x61,0x74,0x75,0x6C,0x61,0x74,0x69,0x6F
	.DB  0x6E,0x20,0x78,0x0
_0x2000003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x0A
	.DW  0x04
	.DW  __REG_VARS*2

	.DW  0x03
	.DW  _sevseg
	.DW  _0x3*2

	.DW  0x11
	.DW  _bord
	.DW  _0x4*2

	.DW  0x02
	.DW  _0x7D
	.DW  _0x0*2

	.DW  0x02
	.DW  _0x7D+2
	.DW  _0x0*2+2

	.DW  0x02
	.DW  _0x7D+4
	.DW  _0x0*2+4

	.DW  0x0C
	.DW  _0x140
	.DW  _0x0*2+9

	.DW  0x09
	.DW  _0x140+12
	.DW  _0x0*2+21

	.DW  0x0F
	.DW  _0x140+21
	.DW  _0x0*2+30

	.DW  0x08
	.DW  _0x140+36
	.DW  _0x0*2+45

	.DW  0x07
	.DW  _0x140+44
	.DW  _0x0*2+80

	.DW  0x07
	.DW  _0x140+51
	.DW  _0x0*2+87

	.DW  0x06
	.DW  _0x140+58
	.DW  _0x0*2+94

	.DW  0x06
	.DW  _0x140+64
	.DW  _0x0*2+100

	.DW  0x0B
	.DW  _0x140+70
	.DW  _0x0*2+106

	.DW  0x07
	.DW  _0x140+81
	.DW  _0x0*2+117

	.DW  0x06
	.DW  _0x140+88
	.DW  _0x0*2+124

	.DW  0x0B
	.DW  _0x140+94
	.DW  _0x0*2+106

	.DW  0x07
	.DW  _0x140+105
	.DW  _0x0*2+117

	.DW  0x11
	.DW  _0x140+112
	.DW  _0x0*2+130

	.DW  0x11
	.DW  _0x140+129
	.DW  _0x0*2+147

	.DW  0x06
	.DW  _0x140+146
	.DW  _0x0*2+124

	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;/*******************************************************
;This program was created by the
;CodeWizardAVR V3.14 Advanced
;Automatic Program Generator
; Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 2/2/2023
;Author  :
;Company :
;Comments:
;
;
;Chip type               : ATmega64
;Program type            : Application
;AVR Core Clock frequency: 1.000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 1024
;*******************************************************/
;
;#include <mega64.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <alcd.h>
;#include <delay.h>
;#include <stdio.h>
;
;#define keypadport PORTD
;#define input PIND
;
;int l=0,l1=0,l3=0;
;unsigned int sevseg[2]={0X06,0X5B};

	.DSEG
;
;int bord[3][3]={{0,1,2},{3,4,5},{6,7,8}};
;char tabdil[20];
;int kelid=20;
;
;
;int round=1;
;int bord_o=0;
;int bord_x=0;
;int nobat=0;//0=x , 1=o
;int valid=0;
;int vazeyat=0;//0= ok 1= yenafar borde
;
;int check_winner()
; 0000 0030 {

	.CSEG
_check_winner:
; .FSTART _check_winner
; 0000 0031       int y=0;//0=kasi naborde , 1-2-3..8= halat haye bord
; 0000 0032       int p=0,q=0;
; 0000 0033       if (nobat==0)
	CALL __SAVELOCR6
;	y -> R16,R17
;	p -> R18,R19
;	q -> R20,R21
	__GETWRN 16,17,0
	__GETWRN 18,19,0
	__GETWRN 20,21,0
	CALL SUBOPT_0x0
	BREQ PC+2
	RJMP _0x5
; 0000 0034       {
; 0000 0035           for (p=0;p<3;p++)
	__GETWRN 18,19,0
_0x7:
	__CPWRN 18,19,3
	BRGE _0x8
; 0000 0036           {
; 0000 0037             if(bord[0][p]==30)
	CALL SUBOPT_0x1
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x9
; 0000 0038             q++;
	__ADDWRN 20,21,1
; 0000 0039           }
_0x9:
	__ADDWRN 18,19,1
	RJMP _0x7
_0x8:
; 0000 003A           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0xA
; 0000 003B             y=1;
	__GETWRN 16,17,1
; 0000 003C           q=0;
_0xA:
	CALL SUBOPT_0x3
; 0000 003D 
; 0000 003E           //////////////////////////
; 0000 003F           for (p=0;p<3;p++)
_0xC:
	__CPWRN 18,19,3
	BRGE _0xD
; 0000 0040           {
; 0000 0041             if(bord[1][p]==30)
	CALL SUBOPT_0x4
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0xE
; 0000 0042             q++;
	__ADDWRN 20,21,1
; 0000 0043           }
_0xE:
	__ADDWRN 18,19,1
	RJMP _0xC
_0xD:
; 0000 0044           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0xF
; 0000 0045             y=2;
	__GETWRN 16,17,2
; 0000 0046           q=0;
_0xF:
	CALL SUBOPT_0x3
; 0000 0047           //////////////////////////
; 0000 0048 
; 0000 0049           for (p=0;p<3;p++)
_0x11:
	__CPWRN 18,19,3
	BRGE _0x12
; 0000 004A           {
; 0000 004B             if(bord[2][p]==30)
	CALL SUBOPT_0x5
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x13
; 0000 004C             q++;
	__ADDWRN 20,21,1
; 0000 004D           }
_0x13:
	__ADDWRN 18,19,1
	RJMP _0x11
_0x12:
; 0000 004E           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x14
; 0000 004F             y=3;
	__GETWRN 16,17,3
; 0000 0050           q=0;
_0x14:
	CALL SUBOPT_0x3
; 0000 0051           ///////////////////////////
; 0000 0052 
; 0000 0053 
; 0000 0054           for (p=0;p<3;p++)
_0x16:
	__CPWRN 18,19,3
	BRGE _0x17
; 0000 0055           {
; 0000 0056             if(bord[p][0]==30)
	CALL SUBOPT_0x6
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	CALL SUBOPT_0x7
	BRNE _0x18
; 0000 0057             q++;
	__ADDWRN 20,21,1
; 0000 0058           }
_0x18:
	__ADDWRN 18,19,1
	RJMP _0x16
_0x17:
; 0000 0059           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x19
; 0000 005A             y=4;
	__GETWRN 16,17,4
; 0000 005B           q=0;
_0x19:
	CALL SUBOPT_0x3
; 0000 005C           ///////////////////////////
; 0000 005D           for (p=0;p<3;p++)
_0x1B:
	__CPWRN 18,19,3
	BRGE _0x1C
; 0000 005E           {
; 0000 005F             if(bord[p][1]==30)
	CALL SUBOPT_0x6
	__ADDW1MN _bord,2
	CALL SUBOPT_0x7
	BRNE _0x1D
; 0000 0060             q++;
	__ADDWRN 20,21,1
; 0000 0061           }
_0x1D:
	__ADDWRN 18,19,1
	RJMP _0x1B
_0x1C:
; 0000 0062           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x1E
; 0000 0063             y=5;
	__GETWRN 16,17,5
; 0000 0064           q=0;
_0x1E:
	CALL SUBOPT_0x3
; 0000 0065           ///////////////////////////
; 0000 0066           for (p=0;p<3;p++)
_0x20:
	__CPWRN 18,19,3
	BRGE _0x21
; 0000 0067           {
; 0000 0068             if(bord[p][2]==30)
	CALL SUBOPT_0x6
	__ADDW1MN _bord,4
	CALL SUBOPT_0x7
	BRNE _0x22
; 0000 0069             q++;
	__ADDWRN 20,21,1
; 0000 006A           }
_0x22:
	__ADDWRN 18,19,1
	RJMP _0x20
_0x21:
; 0000 006B           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x23
; 0000 006C             y=6;
	__GETWRN 16,17,6
; 0000 006D           q=0;
_0x23:
	CALL SUBOPT_0x3
; 0000 006E           ///////////////////////////
; 0000 006F           for (p=0;p<3;p++)
_0x25:
	__CPWRN 18,19,3
	BRGE _0x26
; 0000 0070           {
; 0000 0071             if(bord[p][p]==30)
	CALL SUBOPT_0x6
	CALL SUBOPT_0x8
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x27
; 0000 0072             q++;
	__ADDWRN 20,21,1
; 0000 0073           }
_0x27:
	__ADDWRN 18,19,1
	RJMP _0x25
_0x26:
; 0000 0074           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x28
; 0000 0075             y=7;
	__GETWRN 16,17,7
; 0000 0076           q=0;
_0x28:
	CALL SUBOPT_0x3
; 0000 0077           ///////////////////////////
; 0000 0078           for (p=0;p<3;p++)
_0x2A:
	__CPWRN 18,19,3
	BRGE _0x2B
; 0000 0079           {
; 0000 007A             if(bord[p][2-p]==30)
	CALL SUBOPT_0x6
	CALL SUBOPT_0x9
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x2C
; 0000 007B             q++;
	__ADDWRN 20,21,1
; 0000 007C           }
_0x2C:
	__ADDWRN 18,19,1
	RJMP _0x2A
_0x2B:
; 0000 007D           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x2D
; 0000 007E             y=8;
	__GETWRN 16,17,8
; 0000 007F           q=0;
_0x2D:
	__GETWRN 20,21,0
; 0000 0080       }
; 0000 0081 
; 0000 0082       ///
; 0000 0083       if (nobat==1)
_0x5:
	LDS  R26,_nobat
	LDS  R27,_nobat+1
	SBIW R26,1
	BREQ PC+2
	RJMP _0x2E
; 0000 0084       {
; 0000 0085           for (p=0;p<3;p++)
	__GETWRN 18,19,0
_0x30:
	__CPWRN 18,19,3
	BRGE _0x31
; 0000 0086           {
; 0000 0087             if(bord[0][p]==40)
	CALL SUBOPT_0x1
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BRNE _0x32
; 0000 0088             q++;
	__ADDWRN 20,21,1
; 0000 0089           }
_0x32:
	__ADDWRN 18,19,1
	RJMP _0x30
_0x31:
; 0000 008A           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x33
; 0000 008B             y=1;
	__GETWRN 16,17,1
; 0000 008C           q=0;
_0x33:
	CALL SUBOPT_0x3
; 0000 008D 
; 0000 008E           //////////////////////////
; 0000 008F           for (p=0;p<3;p++)
_0x35:
	__CPWRN 18,19,3
	BRGE _0x36
; 0000 0090           {
; 0000 0091             if(bord[1][p]==40)
	CALL SUBOPT_0x4
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BRNE _0x37
; 0000 0092             q++;
	__ADDWRN 20,21,1
; 0000 0093           }
_0x37:
	__ADDWRN 18,19,1
	RJMP _0x35
_0x36:
; 0000 0094           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x38
; 0000 0095             y=2;
	__GETWRN 16,17,2
; 0000 0096           q=0;
_0x38:
	CALL SUBOPT_0x3
; 0000 0097           //////////////////////////
; 0000 0098 
; 0000 0099           for (p=0;p<3;p++)
_0x3A:
	__CPWRN 18,19,3
	BRGE _0x3B
; 0000 009A           {
; 0000 009B             if(bord[2][p]==40)
	CALL SUBOPT_0x5
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BRNE _0x3C
; 0000 009C             q++;
	__ADDWRN 20,21,1
; 0000 009D           }
_0x3C:
	__ADDWRN 18,19,1
	RJMP _0x3A
_0x3B:
; 0000 009E           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x3D
; 0000 009F             y=3;
	__GETWRN 16,17,3
; 0000 00A0           q=0;
_0x3D:
	CALL SUBOPT_0x3
; 0000 00A1           ///////////////////////////
; 0000 00A2 
; 0000 00A3 
; 0000 00A4           for (p=0;p<3;p++)
_0x3F:
	__CPWRN 18,19,3
	BRGE _0x40
; 0000 00A5           {
; 0000 00A6             if(bord[p][0]==40)
	CALL SUBOPT_0x6
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	CALL SUBOPT_0xA
	BRNE _0x41
; 0000 00A7             q++;
	__ADDWRN 20,21,1
; 0000 00A8           }
_0x41:
	__ADDWRN 18,19,1
	RJMP _0x3F
_0x40:
; 0000 00A9           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x42
; 0000 00AA             y=4;
	__GETWRN 16,17,4
; 0000 00AB           q=0;
_0x42:
	CALL SUBOPT_0x3
; 0000 00AC           ///////////////////////////
; 0000 00AD           for (p=0;p<3;p++)
_0x44:
	__CPWRN 18,19,3
	BRGE _0x45
; 0000 00AE           {
; 0000 00AF             if(bord[p][1]==40)
	CALL SUBOPT_0x6
	__ADDW1MN _bord,2
	CALL SUBOPT_0xA
	BRNE _0x46
; 0000 00B0             q++;
	__ADDWRN 20,21,1
; 0000 00B1           }
_0x46:
	__ADDWRN 18,19,1
	RJMP _0x44
_0x45:
; 0000 00B2           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x47
; 0000 00B3             y=5;
	__GETWRN 16,17,5
; 0000 00B4           q=0;
_0x47:
	CALL SUBOPT_0x3
; 0000 00B5           ///////////////////////////
; 0000 00B6           for (p=0;p<3;p++)
_0x49:
	__CPWRN 18,19,3
	BRGE _0x4A
; 0000 00B7           {
; 0000 00B8             if(bord[p][2]==40)
	CALL SUBOPT_0x6
	__ADDW1MN _bord,4
	CALL SUBOPT_0xA
	BRNE _0x4B
; 0000 00B9             q++;
	__ADDWRN 20,21,1
; 0000 00BA           }
_0x4B:
	__ADDWRN 18,19,1
	RJMP _0x49
_0x4A:
; 0000 00BB           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x4C
; 0000 00BC             y=6;
	__GETWRN 16,17,6
; 0000 00BD           q=0;
_0x4C:
	CALL SUBOPT_0x3
; 0000 00BE           ///////////////////////////
; 0000 00BF           for (p=0;p<3;p++)
_0x4E:
	__CPWRN 18,19,3
	BRGE _0x4F
; 0000 00C0           {
; 0000 00C1             if(bord[p][p]==40)
	CALL SUBOPT_0x6
	CALL SUBOPT_0x8
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BRNE _0x50
; 0000 00C2             q++;
	__ADDWRN 20,21,1
; 0000 00C3           }
_0x50:
	__ADDWRN 18,19,1
	RJMP _0x4E
_0x4F:
; 0000 00C4           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x51
; 0000 00C5             y=7;
	__GETWRN 16,17,7
; 0000 00C6           q=0;
_0x51:
	CALL SUBOPT_0x3
; 0000 00C7           ///////////////////////////
; 0000 00C8           for (p=0;p<3;p++)
_0x53:
	__CPWRN 18,19,3
	BRGE _0x54
; 0000 00C9           {
; 0000 00CA             if(bord[p][2-p]==40)
	CALL SUBOPT_0x6
	CALL SUBOPT_0x9
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BRNE _0x55
; 0000 00CB             q++;
	__ADDWRN 20,21,1
; 0000 00CC           }
_0x55:
	__ADDWRN 18,19,1
	RJMP _0x53
_0x54:
; 0000 00CD           if (q==3)
	CALL SUBOPT_0x2
	BRNE _0x56
; 0000 00CE             y=8;
	__GETWRN 16,17,8
; 0000 00CF           q=0;
_0x56:
	__GETWRN 20,21,0
; 0000 00D0       }
; 0000 00D1 
; 0000 00D2 return y;
_0x2E:
	MOVW R30,R16
	CALL __LOADLOCR6
	RJMP _0x2080005
; 0000 00D3 }
; .FEND
;
;
;int kypad()
; 0000 00D7 {
_kypad:
; .FSTART _kypad
; 0000 00D8     int k=20;
; 0000 00D9     while(k==20)
	ST   -Y,R17
	ST   -Y,R16
;	k -> R16,R17
	__GETWRN 16,17,20
_0x57:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CP   R30,R16
	CPC  R31,R17
	BREQ PC+2
	RJMP _0x59
; 0000 00DA     {
; 0000 00DB     keypadport = 0xEF;
	LDI  R30,LOW(239)
	OUT  0x12,R30
; 0000 00DC 
; 0000 00DD       if ( !input.0 )
	SBIC 0x10,0
	RJMP _0x5A
; 0000 00DE       {
; 0000 00DF          k=7;
	__GETWRN 16,17,7
; 0000 00E0          delay_ms(500);
	RJMP _0x175
; 0000 00E1       }
; 0000 00E2 
; 0000 00E3       else if ( !input.1 )
_0x5A:
	SBIC 0x10,1
	RJMP _0x5C
; 0000 00E4       {
; 0000 00E5          k=4;
	__GETWRN 16,17,4
; 0000 00E6          delay_ms(500);
	RJMP _0x175
; 0000 00E7       }
; 0000 00E8 
; 0000 00E9       else if ( !input.2 )
_0x5C:
	SBIC 0x10,2
	RJMP _0x5E
; 0000 00EA       {
; 0000 00EB          k=1;
	__GETWRN 16,17,1
; 0000 00EC          delay_ms(500);
	RJMP _0x175
; 0000 00ED       }
; 0000 00EE 
; 0000 00EF       else if ( !input.3 )
_0x5E:
	SBIC 0x10,3
	RJMP _0x60
; 0000 00F0       {
; 0000 00F1          k=10;
	__GETWRN 16,17,10
; 0000 00F2          delay_ms(500);
_0x175:
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 00F3       }
; 0000 00F4 
; 0000 00F5       keypadport = 0xDF;
_0x60:
	LDI  R30,LOW(223)
	OUT  0x12,R30
; 0000 00F6 
; 0000 00F7       if ( !input.0 )
	SBIC 0x10,0
	RJMP _0x61
; 0000 00F8       {
; 0000 00F9          k=8;
	__GETWRN 16,17,8
; 0000 00FA          delay_ms(500);
	RJMP _0x176
; 0000 00FB       }
; 0000 00FC 
; 0000 00FD       else if ( !input.1 )
_0x61:
	SBIC 0x10,1
	RJMP _0x63
; 0000 00FE       {
; 0000 00FF          k=5;
	__GETWRN 16,17,5
; 0000 0100          delay_ms(500);
	RJMP _0x176
; 0000 0101       }
; 0000 0102 
; 0000 0103       else if ( !input.2 )
_0x63:
	SBIC 0x10,2
	RJMP _0x65
; 0000 0104       {
; 0000 0105          k=2;
	__GETWRN 16,17,2
; 0000 0106          delay_ms(500);
	RJMP _0x176
; 0000 0107       }
; 0000 0108 
; 0000 0109       else if ( !input.3 )
_0x65:
	SBIC 0x10,3
	RJMP _0x67
; 0000 010A       {
; 0000 010B          k=0;
	__GETWRN 16,17,0
; 0000 010C          delay_ms(500);
_0x176:
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 010D       }
; 0000 010E 
; 0000 010F       keypadport = 0xBF;
_0x67:
	LDI  R30,LOW(191)
	OUT  0x12,R30
; 0000 0110 
; 0000 0111       if ( !input.0 )
	SBIC 0x10,0
	RJMP _0x68
; 0000 0112       {
; 0000 0113          k=9;
	__GETWRN 16,17,9
; 0000 0114          delay_ms(500);
	RJMP _0x177
; 0000 0115       }
; 0000 0116 
; 0000 0117       else if ( !input.1 )
_0x68:
	SBIC 0x10,1
	RJMP _0x6A
; 0000 0118       {
; 0000 0119          k=6;
	__GETWRN 16,17,6
; 0000 011A          delay_ms(500);
	RJMP _0x177
; 0000 011B       }
; 0000 011C 
; 0000 011D       else if ( !input.2 )
_0x6A:
	SBIC 0x10,2
	RJMP _0x6C
; 0000 011E       {
; 0000 011F          k=3;
	__GETWRN 16,17,3
; 0000 0120          delay_ms(500);
	RJMP _0x177
; 0000 0121       }
; 0000 0122 
; 0000 0123       else if ( !input.3 )
_0x6C:
	SBIC 0x10,3
	RJMP _0x6E
; 0000 0124       {
; 0000 0125         k=14;
	__GETWRN 16,17,14
; 0000 0126         delay_ms(500);
_0x177:
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 0127       }
; 0000 0128 
; 0000 0129             keypadport = 0x7F;
_0x6E:
	LDI  R30,LOW(127)
	OUT  0x12,R30
; 0000 012A 
; 0000 012B       if ( !input.0 )
	SBIC 0x10,0
	RJMP _0x6F
; 0000 012C       {
; 0000 012D         k=10;
	__GETWRN 16,17,10
; 0000 012E         delay_ms(500);
	RJMP _0x178
; 0000 012F       }
; 0000 0130 
; 0000 0131       else if ( !input.1 )
_0x6F:
	SBIC 0x10,1
	RJMP _0x71
; 0000 0132       {
; 0000 0133         k=11;
	__GETWRN 16,17,11
; 0000 0134         delay_ms(500);
	RJMP _0x178
; 0000 0135       }
; 0000 0136 
; 0000 0137       else if ( !input.2 )
_0x71:
	SBIC 0x10,2
	RJMP _0x73
; 0000 0138       {
; 0000 0139         k=12;
	__GETWRN 16,17,12
; 0000 013A         delay_ms(500);
	RJMP _0x178
; 0000 013B       }
; 0000 013C 
; 0000 013D       else if ( !input.3 )
_0x73:
	SBIC 0x10,3
	RJMP _0x75
; 0000 013E       {
; 0000 013F         k=13;
	__GETWRN 16,17,13
; 0000 0140         delay_ms(500);
_0x178:
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 0141       }
; 0000 0142       }
_0x75:
	RJMP _0x57
_0x59:
; 0000 0143       return k;
	MOVW R30,R16
	LD   R16,Y+
	LD   R17,Y+
	RET
; 0000 0144 }
; .FEND
;
;void lcdshow()
; 0000 0147 {
_lcdshow:
; .FSTART _lcdshow
; 0000 0148     int i=0,j=0;
; 0000 0149     for (i=0;i<3;i++)
	CALL __SAVELOCR4
;	i -> R16,R17
;	j -> R18,R19
	__GETWRN 16,17,0
	__GETWRN 18,19,0
	__GETWRN 16,17,0
_0x77:
	__CPWRN 16,17,3
	BRLT PC+2
	RJMP _0x78
; 0000 014A     {
; 0000 014B         for (j=0;j<3;j++)
	__GETWRN 18,19,0
_0x7A:
	__CPWRN 18,19,3
	BRGE _0x7B
; 0000 014C         {
; 0000 014D             lcd_gotoxy(i,j+1);
	ST   -Y,R16
	MOV  R26,R18
	SUBI R26,-LOW(1)
	CALL _lcd_gotoxy
; 0000 014E             if(bord[j][i]==30){
	CALL SUBOPT_0x6
	CALL SUBOPT_0xB
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x7C
; 0000 014F                 lcd_puts("X");
	__POINTW2MN _0x7D,0
	RJMP _0x179
; 0000 0150             } else if(bord[j][i]==40){
_0x7C:
	CALL SUBOPT_0x6
	CALL SUBOPT_0xB
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BRNE _0x7F
; 0000 0151                 lcd_puts("O");
	__POINTW2MN _0x7D,2
	RJMP _0x179
; 0000 0152             }  else if(bord[j][i]==35){
_0x7F:
	CALL SUBOPT_0x6
	CALL SUBOPT_0xB
	CPI  R30,LOW(0x23)
	LDI  R26,HIGH(0x23)
	CPC  R31,R26
	BRNE _0x81
; 0000 0153                 lcd_puts(" ");
	__POINTW2MN _0x7D,4
	RJMP _0x179
; 0000 0154             }else{
_0x81:
; 0000 0155                 sprintf(tabdil,"%d",bord[j][i]);
	CALL SUBOPT_0xC
	__POINTW1FN _0x0,6
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x6
	CALL SUBOPT_0xB
	CALL SUBOPT_0xD
; 0000 0156                 lcd_puts(tabdil);
_0x179:
	CALL _lcd_puts
; 0000 0157             }
; 0000 0158         }
	__ADDWRN 18,19,1
	RJMP _0x7A
_0x7B:
; 0000 0159     }
	__ADDWRN 16,17,1
	RJMP _0x77
_0x78:
; 0000 015A 
; 0000 015B }
	CALL __LOADLOCR4
	RJMP _0x2080004
; .FEND

	.DSEG
_0x7D:
	.BYTE 0x6
;
;int movevalid(int a)
; 0000 015E {

	.CSEG
_movevalid:
; .FSTART _movevalid
; 0000 015F     int b=1;
; 0000 0160     if (a<3)
	CALL SUBOPT_0xE
;	a -> Y+2
;	b -> R16,R17
	__GETWRN 16,17,1
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,3
	BRGE _0x83
; 0000 0161     {
; 0000 0162         if ((bord[0][a]==30) || (bord[0][a]==40))
	CALL SUBOPT_0xF
	CALL SUBOPT_0x10
	BREQ _0x85
	CALL SUBOPT_0x11
	BRNE _0x84
_0x85:
; 0000 0163             b=0;
	__GETWRN 16,17,0
; 0000 0164     } else if (a<6)  {
_0x84:
	RJMP _0x87
_0x83:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,6
	BRGE _0x88
; 0000 0165         if ((bord[1][a-3]==30) || (bord[1][a-3]==40))
	CALL SUBOPT_0x12
	CALL SUBOPT_0x10
	BREQ _0x8A
	CALL SUBOPT_0x11
	BRNE _0x89
_0x8A:
; 0000 0166             b=0;
	__GETWRN 16,17,0
; 0000 0167     }else if(a<9){
_0x89:
	RJMP _0x8C
_0x88:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,9
	BRGE _0x8D
; 0000 0168         if ((bord[2][a-6]==30) || (bord[2][a-6]==40))
	CALL SUBOPT_0x13
	CALL SUBOPT_0x10
	BREQ _0x8F
	CALL SUBOPT_0x11
	BRNE _0x8E
_0x8F:
; 0000 0169             b=0;
	__GETWRN 16,17,0
; 0000 016A     }else{
_0x8E:
	RJMP _0x91
_0x8D:
; 0000 016B         b=0;
	__GETWRN 16,17,0
; 0000 016C     }
_0x91:
_0x8C:
_0x87:
; 0000 016D     return b;
	MOVW R30,R16
	RJMP _0x2080003
; 0000 016E }
; .FEND
;
;void tikwin(int a)
; 0000 0171 {
_tikwin:
; .FSTART _tikwin
; 0000 0172     int i=0,p;
; 0000 0173     if (nobat==0){
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR4
;	a -> Y+4
;	i -> R16,R17
;	p -> R18,R19
	__GETWRN 16,17,0
	CALL SUBOPT_0x0
	BREQ PC+2
	RJMP _0x92
; 0000 0174 
; 0000 0175         if (a==1)
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,1
	BRNE _0x93
; 0000 0176         {
; 0000 0177             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0x95:
	__CPWRN 16,17,4
	BRGE _0x96
; 0000 0178             {
; 0000 0179             lcdshow();
	CALL SUBOPT_0x14
; 0000 017A              delay_ms(250);
; 0000 017B              for (p=0;p<3;p++)
_0x98:
	__CPWRN 18,19,3
	BRGE _0x99
; 0000 017C              {
; 0000 017D                 bord[0][p]=35;
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
; 0000 017E              }
	__ADDWRN 18,19,1
	RJMP _0x98
_0x99:
; 0000 017F              lcdshow();
	CALL SUBOPT_0x17
; 0000 0180              delay_ms(500);
; 0000 0181              for (p=0;p<3;p++)
_0x9B:
	__CPWRN 18,19,3
	BRGE _0x9C
; 0000 0182              {
; 0000 0183                 bord[0][p]=30;
	CALL SUBOPT_0x15
	CALL SUBOPT_0x18
; 0000 0184              }
	__ADDWRN 18,19,1
	RJMP _0x9B
_0x9C:
; 0000 0185              lcdshow();
	CALL SUBOPT_0x19
; 0000 0186              delay_ms(750);
; 0000 0187              }
	__ADDWRN 16,17,1
	RJMP _0x95
_0x96:
; 0000 0188         }
; 0000 0189         ////
; 0000 018A         if (a==2)
_0x93:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,2
	BRNE _0x9D
; 0000 018B         {
; 0000 018C             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0x9F:
	__CPWRN 16,17,4
	BRGE _0xA0
; 0000 018D             {
; 0000 018E             lcdshow();
	CALL SUBOPT_0x14
; 0000 018F              delay_ms(250);
; 0000 0190              for (p=0;p<3;p++)
_0xA2:
	__CPWRN 18,19,3
	BRGE _0xA3
; 0000 0191              {
; 0000 0192                 bord[1][p]=35;
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x16
; 0000 0193              }
	__ADDWRN 18,19,1
	RJMP _0xA2
_0xA3:
; 0000 0194              lcdshow();
	CALL SUBOPT_0x17
; 0000 0195              delay_ms(500);
; 0000 0196              for (p=0;p<3;p++)
_0xA5:
	__CPWRN 18,19,3
	BRGE _0xA6
; 0000 0197              {
; 0000 0198                 bord[1][p]=30;
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x18
; 0000 0199              }
	__ADDWRN 18,19,1
	RJMP _0xA5
_0xA6:
; 0000 019A              lcdshow();
	CALL SUBOPT_0x19
; 0000 019B              delay_ms(750);
; 0000 019C              }
	__ADDWRN 16,17,1
	RJMP _0x9F
_0xA0:
; 0000 019D         }
; 0000 019E         ////
; 0000 019F         if (a==3)
_0x9D:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,3
	BRNE _0xA7
; 0000 01A0         {
; 0000 01A1             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0xA9:
	__CPWRN 16,17,4
	BRGE _0xAA
; 0000 01A2             {
; 0000 01A3             lcdshow();
	CALL SUBOPT_0x14
; 0000 01A4              delay_ms(250);
; 0000 01A5              for (p=0;p<3;p++)
_0xAC:
	__CPWRN 18,19,3
	BRGE _0xAD
; 0000 01A6              {
; 0000 01A7                 bord[2][p]=35;
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x16
; 0000 01A8              }
	__ADDWRN 18,19,1
	RJMP _0xAC
_0xAD:
; 0000 01A9              lcdshow();
	CALL SUBOPT_0x17
; 0000 01AA              delay_ms(500);
; 0000 01AB              for (p=0;p<3;p++)
_0xAF:
	__CPWRN 18,19,3
	BRGE _0xB0
; 0000 01AC              {
; 0000 01AD                 bord[2][p]=30;
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x18
; 0000 01AE              }
	__ADDWRN 18,19,1
	RJMP _0xAF
_0xB0:
; 0000 01AF              lcdshow();
	CALL SUBOPT_0x19
; 0000 01B0              delay_ms(750);
; 0000 01B1              }
	__ADDWRN 16,17,1
	RJMP _0xA9
_0xAA:
; 0000 01B2         }
; 0000 01B3         ////
; 0000 01B4         if (a==4)
_0xA7:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,4
	BRNE _0xB1
; 0000 01B5         {
; 0000 01B6             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0xB3:
	__CPWRN 16,17,4
	BRGE _0xB4
; 0000 01B7             {
; 0000 01B8             lcdshow();
	CALL SUBOPT_0x14
; 0000 01B9              delay_ms(250);
; 0000 01BA              for (p=0;p<3;p++)
_0xB6:
	__CPWRN 18,19,3
	BRGE _0xB7
; 0000 01BB              {
; 0000 01BC                 bord[p][0]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1C
; 0000 01BD              }
	__ADDWRN 18,19,1
	RJMP _0xB6
_0xB7:
; 0000 01BE              lcdshow();
	CALL SUBOPT_0x17
; 0000 01BF              delay_ms(500);
; 0000 01C0              for (p=0;p<3;p++)
_0xB9:
	__CPWRN 18,19,3
	BRGE _0xBA
; 0000 01C1              {
; 0000 01C2                 bord[p][0]=30;
	CALL SUBOPT_0x6
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	CALL SUBOPT_0x1D
; 0000 01C3              }
	__ADDWRN 18,19,1
	RJMP _0xB9
_0xBA:
; 0000 01C4              lcdshow();
	CALL SUBOPT_0x19
; 0000 01C5              delay_ms(750);
; 0000 01C6              }
	__ADDWRN 16,17,1
	RJMP _0xB3
_0xB4:
; 0000 01C7         }
; 0000 01C8         ////
; 0000 01C9         if (a==5)
_0xB1:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,5
	BRNE _0xBB
; 0000 01CA         {
; 0000 01CB             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0xBD:
	__CPWRN 16,17,4
	BRGE _0xBE
; 0000 01CC             {
; 0000 01CD             lcdshow();
	CALL SUBOPT_0x14
; 0000 01CE              delay_ms(250);
; 0000 01CF              for (p=0;p<3;p++)
_0xC0:
	__CPWRN 18,19,3
	BRGE _0xC1
; 0000 01D0              {
; 0000 01D1                 bord[p][1]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1E
; 0000 01D2              }
	__ADDWRN 18,19,1
	RJMP _0xC0
_0xC1:
; 0000 01D3              lcdshow();
	CALL SUBOPT_0x17
; 0000 01D4              delay_ms(500);
; 0000 01D5              for (p=0;p<3;p++)
_0xC3:
	__CPWRN 18,19,3
	BRGE _0xC4
; 0000 01D6              {
; 0000 01D7                 bord[p][1]=30;
	CALL SUBOPT_0x6
	__ADDW1MN _bord,2
	CALL SUBOPT_0x1D
; 0000 01D8              }
	__ADDWRN 18,19,1
	RJMP _0xC3
_0xC4:
; 0000 01D9              lcdshow();
	CALL SUBOPT_0x19
; 0000 01DA              delay_ms(750);
; 0000 01DB              }
	__ADDWRN 16,17,1
	RJMP _0xBD
_0xBE:
; 0000 01DC         }
; 0000 01DD         ////
; 0000 01DE         if (a==6)
_0xBB:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,6
	BRNE _0xC5
; 0000 01DF         {
; 0000 01E0             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0xC7:
	__CPWRN 16,17,4
	BRGE _0xC8
; 0000 01E1             {
; 0000 01E2             lcdshow();
	CALL SUBOPT_0x14
; 0000 01E3              delay_ms(250);
; 0000 01E4              for (p=0;p<3;p++)
_0xCA:
	__CPWRN 18,19,3
	BRGE _0xCB
; 0000 01E5              {
; 0000 01E6                 bord[p][2]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1F
; 0000 01E7              }
	__ADDWRN 18,19,1
	RJMP _0xCA
_0xCB:
; 0000 01E8              lcdshow();
	CALL SUBOPT_0x17
; 0000 01E9              delay_ms(500);
; 0000 01EA              for (p=0;p<3;p++)
_0xCD:
	__CPWRN 18,19,3
	BRGE _0xCE
; 0000 01EB              {
; 0000 01EC                 bord[p][2]=30;
	CALL SUBOPT_0x6
	__ADDW1MN _bord,4
	CALL SUBOPT_0x1D
; 0000 01ED              }
	__ADDWRN 18,19,1
	RJMP _0xCD
_0xCE:
; 0000 01EE              lcdshow();
	CALL SUBOPT_0x19
; 0000 01EF              delay_ms(750);
; 0000 01F0              }
	__ADDWRN 16,17,1
	RJMP _0xC7
_0xC8:
; 0000 01F1         }
; 0000 01F2         ////
; 0000 01F3         if (a==7)
_0xC5:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,7
	BRNE _0xCF
; 0000 01F4         {
; 0000 01F5             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0xD1:
	__CPWRN 16,17,4
	BRGE _0xD2
; 0000 01F6             {
; 0000 01F7             lcdshow();
	CALL SUBOPT_0x14
; 0000 01F8              delay_ms(250);
; 0000 01F9              for (p=0;p<3;p++)
_0xD4:
	__CPWRN 18,19,3
	BRGE _0xD5
; 0000 01FA              {
; 0000 01FB                 bord[p][p]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x20
	CALL SUBOPT_0x16
; 0000 01FC              }
	__ADDWRN 18,19,1
	RJMP _0xD4
_0xD5:
; 0000 01FD              lcdshow();
	CALL SUBOPT_0x17
; 0000 01FE              delay_ms(500);
; 0000 01FF              for (p=0;p<3;p++)
_0xD7:
	__CPWRN 18,19,3
	BRGE _0xD8
; 0000 0200              {
; 0000 0201                 bord[p][p]=30;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x20
	CALL SUBOPT_0x18
; 0000 0202              }
	__ADDWRN 18,19,1
	RJMP _0xD7
_0xD8:
; 0000 0203              lcdshow();
	CALL SUBOPT_0x19
; 0000 0204              delay_ms(750);
; 0000 0205              }
	__ADDWRN 16,17,1
	RJMP _0xD1
_0xD2:
; 0000 0206         }
; 0000 0207         ////
; 0000 0208         if (a==8)
_0xCF:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,8
	BRNE _0xD9
; 0000 0209         {
; 0000 020A             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0xDB:
	__CPWRN 16,17,4
	BRGE _0xDC
; 0000 020B             {
; 0000 020C             lcdshow();
	CALL SUBOPT_0x14
; 0000 020D              delay_ms(250);
; 0000 020E              for (p=0;p<3;p++)
_0xDE:
	__CPWRN 18,19,3
	BRGE _0xDF
; 0000 020F              {
; 0000 0210                 bord[p][2-p]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x21
	CALL SUBOPT_0x16
; 0000 0211              }
	__ADDWRN 18,19,1
	RJMP _0xDE
_0xDF:
; 0000 0212              lcdshow();
	CALL SUBOPT_0x17
; 0000 0213              delay_ms(500);
; 0000 0214              for (p=0;p<3;p++)
_0xE1:
	__CPWRN 18,19,3
	BRGE _0xE2
; 0000 0215              {
; 0000 0216                 bord[p][2-p]=30;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x21
	CALL SUBOPT_0x18
; 0000 0217              }
	__ADDWRN 18,19,1
	RJMP _0xE1
_0xE2:
; 0000 0218              lcdshow();
	CALL SUBOPT_0x19
; 0000 0219              delay_ms(750);
; 0000 021A              }
	__ADDWRN 16,17,1
	RJMP _0xDB
_0xDC:
; 0000 021B         }
; 0000 021C      ////////////////////////////////////
; 0000 021D     }else{
_0xD9:
	RJMP _0xE3
_0x92:
; 0000 021E         if (a==1)
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,1
	BRNE _0xE4
; 0000 021F         {
; 0000 0220             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0xE6:
	__CPWRN 16,17,4
	BRGE _0xE7
; 0000 0221             {
; 0000 0222             lcdshow();
	CALL SUBOPT_0x14
; 0000 0223              delay_ms(250);
; 0000 0224              for (p=0;p<3;p++)
_0xE9:
	__CPWRN 18,19,3
	BRGE _0xEA
; 0000 0225              {
; 0000 0226                 bord[0][p]=35;
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
; 0000 0227              }
	__ADDWRN 18,19,1
	RJMP _0xE9
_0xEA:
; 0000 0228              lcdshow();
	CALL SUBOPT_0x17
; 0000 0229              delay_ms(500);
; 0000 022A              for (p=0;p<3;p++)
_0xEC:
	__CPWRN 18,19,3
	BRGE _0xED
; 0000 022B              {
; 0000 022C                 bord[0][p]=40;
	CALL SUBOPT_0x15
	CALL SUBOPT_0x22
; 0000 022D              }
	__ADDWRN 18,19,1
	RJMP _0xEC
_0xED:
; 0000 022E              lcdshow();
	CALL SUBOPT_0x19
; 0000 022F              delay_ms(750);
; 0000 0230              }
	__ADDWRN 16,17,1
	RJMP _0xE6
_0xE7:
; 0000 0231         }
; 0000 0232         ////
; 0000 0233         if (a==2)
_0xE4:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,2
	BRNE _0xEE
; 0000 0234         {
; 0000 0235             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0xF0:
	__CPWRN 16,17,4
	BRGE _0xF1
; 0000 0236             {
; 0000 0237             lcdshow();
	CALL SUBOPT_0x14
; 0000 0238              delay_ms(250);
; 0000 0239              for (p=0;p<3;p++)
_0xF3:
	__CPWRN 18,19,3
	BRGE _0xF4
; 0000 023A              {
; 0000 023B                 bord[1][p]=35;
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x16
; 0000 023C              }
	__ADDWRN 18,19,1
	RJMP _0xF3
_0xF4:
; 0000 023D              lcdshow();
	CALL SUBOPT_0x17
; 0000 023E              delay_ms(500);
; 0000 023F              for (p=0;p<3;p++)
_0xF6:
	__CPWRN 18,19,3
	BRGE _0xF7
; 0000 0240              {
; 0000 0241                 bord[1][p]=40;
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x22
; 0000 0242              }
	__ADDWRN 18,19,1
	RJMP _0xF6
_0xF7:
; 0000 0243              lcdshow();
	CALL SUBOPT_0x19
; 0000 0244              delay_ms(750);
; 0000 0245              }
	__ADDWRN 16,17,1
	RJMP _0xF0
_0xF1:
; 0000 0246         }
; 0000 0247         ////
; 0000 0248         if (a==3)
_0xEE:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,3
	BRNE _0xF8
; 0000 0249         {
; 0000 024A             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0xFA:
	__CPWRN 16,17,4
	BRGE _0xFB
; 0000 024B             {
; 0000 024C             lcdshow();
	CALL SUBOPT_0x14
; 0000 024D              delay_ms(250);
; 0000 024E              for (p=0;p<3;p++)
_0xFD:
	__CPWRN 18,19,3
	BRGE _0xFE
; 0000 024F              {
; 0000 0250                 bord[2][p]=35;
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x16
; 0000 0251              }
	__ADDWRN 18,19,1
	RJMP _0xFD
_0xFE:
; 0000 0252              lcdshow();
	CALL SUBOPT_0x17
; 0000 0253              delay_ms(500);
; 0000 0254              for (p=0;p<3;p++)
_0x100:
	__CPWRN 18,19,3
	BRGE _0x101
; 0000 0255              {
; 0000 0256                 bord[2][p]=40;
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x22
; 0000 0257              }
	__ADDWRN 18,19,1
	RJMP _0x100
_0x101:
; 0000 0258              lcdshow();
	CALL SUBOPT_0x19
; 0000 0259              delay_ms(750);
; 0000 025A              }
	__ADDWRN 16,17,1
	RJMP _0xFA
_0xFB:
; 0000 025B         }
; 0000 025C         ////
; 0000 025D         if (a==4)
_0xF8:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,4
	BRNE _0x102
; 0000 025E         {
; 0000 025F             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0x104:
	__CPWRN 16,17,4
	BRGE _0x105
; 0000 0260             {
; 0000 0261             lcdshow();
	CALL SUBOPT_0x14
; 0000 0262              delay_ms(250);
; 0000 0263              for (p=0;p<3;p++)
_0x107:
	__CPWRN 18,19,3
	BRGE _0x108
; 0000 0264              {
; 0000 0265                 bord[p][0]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1C
; 0000 0266              }
	__ADDWRN 18,19,1
	RJMP _0x107
_0x108:
; 0000 0267              lcdshow();
	CALL SUBOPT_0x17
; 0000 0268              delay_ms(500);
; 0000 0269              for (p=0;p<3;p++)
_0x10A:
	__CPWRN 18,19,3
	BRGE _0x10B
; 0000 026A              {
; 0000 026B                 bord[p][0]=40;
	CALL SUBOPT_0x6
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	CALL SUBOPT_0x23
; 0000 026C              }
	__ADDWRN 18,19,1
	RJMP _0x10A
_0x10B:
; 0000 026D              lcdshow();
	CALL SUBOPT_0x19
; 0000 026E              delay_ms(750);
; 0000 026F              }
	__ADDWRN 16,17,1
	RJMP _0x104
_0x105:
; 0000 0270         }
; 0000 0271         ////
; 0000 0272         if (a==5)
_0x102:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,5
	BRNE _0x10C
; 0000 0273         {
; 0000 0274             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0x10E:
	__CPWRN 16,17,4
	BRGE _0x10F
; 0000 0275             {
; 0000 0276             lcdshow();
	CALL SUBOPT_0x14
; 0000 0277              delay_ms(250);
; 0000 0278              for (p=0;p<3;p++)
_0x111:
	__CPWRN 18,19,3
	BRGE _0x112
; 0000 0279              {
; 0000 027A                 bord[p][1]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1E
; 0000 027B              }
	__ADDWRN 18,19,1
	RJMP _0x111
_0x112:
; 0000 027C              lcdshow();
	CALL SUBOPT_0x17
; 0000 027D              delay_ms(500);
; 0000 027E              for (p=0;p<3;p++)
_0x114:
	__CPWRN 18,19,3
	BRGE _0x115
; 0000 027F              {
; 0000 0280                 bord[p][1]=40;
	CALL SUBOPT_0x6
	__ADDW1MN _bord,2
	CALL SUBOPT_0x23
; 0000 0281              }
	__ADDWRN 18,19,1
	RJMP _0x114
_0x115:
; 0000 0282              lcdshow();
	CALL SUBOPT_0x19
; 0000 0283              delay_ms(750);
; 0000 0284              }
	__ADDWRN 16,17,1
	RJMP _0x10E
_0x10F:
; 0000 0285         }
; 0000 0286         ////
; 0000 0287         if (a==6)
_0x10C:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,6
	BRNE _0x116
; 0000 0288         {
; 0000 0289             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0x118:
	__CPWRN 16,17,4
	BRGE _0x119
; 0000 028A             {
; 0000 028B             lcdshow();
	CALL SUBOPT_0x14
; 0000 028C              delay_ms(250);
; 0000 028D              for (p=0;p<3;p++)
_0x11B:
	__CPWRN 18,19,3
	BRGE _0x11C
; 0000 028E              {
; 0000 028F                 bord[p][2]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1F
; 0000 0290              }
	__ADDWRN 18,19,1
	RJMP _0x11B
_0x11C:
; 0000 0291              lcdshow();
	CALL SUBOPT_0x17
; 0000 0292              delay_ms(500);
; 0000 0293              for (p=0;p<3;p++)
_0x11E:
	__CPWRN 18,19,3
	BRGE _0x11F
; 0000 0294              {
; 0000 0295                 bord[p][2]=40;
	CALL SUBOPT_0x6
	__ADDW1MN _bord,4
	CALL SUBOPT_0x23
; 0000 0296              }
	__ADDWRN 18,19,1
	RJMP _0x11E
_0x11F:
; 0000 0297              lcdshow();
	CALL SUBOPT_0x19
; 0000 0298              delay_ms(750);
; 0000 0299              }
	__ADDWRN 16,17,1
	RJMP _0x118
_0x119:
; 0000 029A         }
; 0000 029B         ////
; 0000 029C         if (a==7)
_0x116:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,7
	BRNE _0x120
; 0000 029D         {
; 0000 029E             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0x122:
	__CPWRN 16,17,4
	BRGE _0x123
; 0000 029F             {
; 0000 02A0             lcdshow();
	CALL SUBOPT_0x14
; 0000 02A1              delay_ms(250);
; 0000 02A2              for (p=0;p<3;p++)
_0x125:
	__CPWRN 18,19,3
	BRGE _0x126
; 0000 02A3              {
; 0000 02A4                 bord[p][p]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x20
	CALL SUBOPT_0x16
; 0000 02A5              }
	__ADDWRN 18,19,1
	RJMP _0x125
_0x126:
; 0000 02A6              lcdshow();
	CALL SUBOPT_0x17
; 0000 02A7              delay_ms(500);
; 0000 02A8              for (p=0;p<3;p++)
_0x128:
	__CPWRN 18,19,3
	BRGE _0x129
; 0000 02A9              {
; 0000 02AA                 bord[p][p]=40;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x20
	CALL SUBOPT_0x22
; 0000 02AB              }
	__ADDWRN 18,19,1
	RJMP _0x128
_0x129:
; 0000 02AC              lcdshow();
	CALL SUBOPT_0x19
; 0000 02AD              delay_ms(750);
; 0000 02AE              }
	__ADDWRN 16,17,1
	RJMP _0x122
_0x123:
; 0000 02AF         }
; 0000 02B0         ////
; 0000 02B1         if (a==8)
_0x120:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,8
	BRNE _0x12A
; 0000 02B2         {
; 0000 02B3             for (i=0;i<4;i++)
	__GETWRN 16,17,0
_0x12C:
	__CPWRN 16,17,4
	BRGE _0x12D
; 0000 02B4             {
; 0000 02B5             lcdshow();
	CALL SUBOPT_0x14
; 0000 02B6              delay_ms(250);
; 0000 02B7              for (p=0;p<3;p++)
_0x12F:
	__CPWRN 18,19,3
	BRGE _0x130
; 0000 02B8              {
; 0000 02B9                 bord[p][2-p]=35;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x21
	CALL SUBOPT_0x16
; 0000 02BA              }
	__ADDWRN 18,19,1
	RJMP _0x12F
_0x130:
; 0000 02BB              lcdshow();
	CALL SUBOPT_0x17
; 0000 02BC              delay_ms(500);
; 0000 02BD              for (p=0;p<3;p++)
_0x132:
	__CPWRN 18,19,3
	BRGE _0x133
; 0000 02BE              {
; 0000 02BF                 bord[p][2-p]=40;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x21
	CALL SUBOPT_0x22
; 0000 02C0              }
	__ADDWRN 18,19,1
	RJMP _0x132
_0x133:
; 0000 02C1              lcdshow();
	CALL SUBOPT_0x19
; 0000 02C2              delay_ms(750);
; 0000 02C3              }
	__ADDWRN 16,17,1
	RJMP _0x12C
_0x12D:
; 0000 02C4         }
; 0000 02C5     }
_0x12A:
_0xE3:
; 0000 02C6 
; 0000 02C7 }
	CALL __LOADLOCR4
_0x2080005:
	ADIW R28,6
	RET
; .FEND
;
;
;int change(int a)
; 0000 02CB {
_change:
; .FSTART _change
; 0000 02CC     int k=0;
; 0000 02CD     if (a<3)
	CALL SUBOPT_0xE
;	a -> Y+2
;	k -> R16,R17
	__GETWRN 16,17,0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,3
	BRGE _0x134
; 0000 02CE     {
; 0000 02CF         if(nobat==0)
	CALL SUBOPT_0x0
	BRNE _0x135
; 0000 02D0             {
; 0000 02D1                 bord[0][a]=30;
	CALL SUBOPT_0xF
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RJMP _0x17A
; 0000 02D2                 lcdshow();
; 0000 02D3             }else{
_0x135:
; 0000 02D4                 bord[0][a]=40;
	CALL SUBOPT_0xF
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
_0x17A:
	ST   X+,R30
	ST   X,R31
; 0000 02D5                 lcdshow();
	RCALL _lcdshow
; 0000 02D6             }
; 0000 02D7     } else if (a<6)  {
	RJMP _0x137
_0x134:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,6
	BRGE _0x138
; 0000 02D8         if(nobat==0)
	CALL SUBOPT_0x0
	BRNE _0x139
; 0000 02D9             {
; 0000 02DA                 bord[1][a-3]=30;
	CALL SUBOPT_0x12
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RJMP _0x17B
; 0000 02DB                 lcdshow();
; 0000 02DC             }else{
_0x139:
; 0000 02DD                 bord[1][a-3]=40;
	CALL SUBOPT_0x12
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
_0x17B:
	ST   X+,R30
	ST   X,R31
; 0000 02DE                 lcdshow();
	RCALL _lcdshow
; 0000 02DF             }
; 0000 02E0     }else {
	RJMP _0x13B
_0x138:
; 0000 02E1        if(nobat==0)
	CALL SUBOPT_0x0
	BRNE _0x13C
; 0000 02E2             {
; 0000 02E3                 bord[2][a-6]=30;
	CALL SUBOPT_0x13
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RJMP _0x17C
; 0000 02E4                 lcdshow();
; 0000 02E5             }else{
_0x13C:
; 0000 02E6                 bord[2][a-6]=40;
	CALL SUBOPT_0x13
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
_0x17C:
	ST   X+,R30
	ST   X,R31
; 0000 02E7                 lcdshow();
	RCALL _lcdshow
; 0000 02E8             }
; 0000 02E9     }
_0x13B:
_0x137:
; 0000 02EA     k=check_winner();
	RCALL _check_winner
	MOVW R16,R30
; 0000 02EB     if(k==0){   //0=ok , 1=yeki borde
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x13E
; 0000 02EC         return 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x2080003
; 0000 02ED     } else {
_0x13E:
; 0000 02EE         tikwin(k);
	MOVW R26,R16
	RCALL _tikwin
; 0000 02EF         return 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
; 0000 02F0     }
; 0000 02F1 }
_0x2080003:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x2080004:
	ADIW R28,4
	RET
; .FEND
;
;void main(void)
; 0000 02F4 {
_main:
; .FSTART _main
; 0000 02F5 
; 0000 02F6 PORTA = 0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 02F7 DDRA  = 0xFF;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
; 0000 02F8 
; 0000 02F9 PORTB = 0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 02FA DDRB  = 0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 02FB 
; 0000 02FC PORTD = 0xEF;
	LDI  R30,LOW(239)
	OUT  0x12,R30
; 0000 02FD DDRD  = 0xF0;
	LDI  R30,LOW(240)
	OUT  0x11,R30
; 0000 02FE 
; 0000 02FF 
; 0000 0300 
; 0000 0301 
; 0000 0302 lcd_init(16);
	LDI  R26,LOW(16)
	CALL _lcd_init
; 0000 0303 lcd_clear();
	RCALL _lcd_clear
; 0000 0304 
; 0000 0305 //start
; 0000 0306 lcd_gotoxy(3,1);
	LDI  R30,LOW(3)
	CALL SUBOPT_0x24
; 0000 0307 lcd_puts("Wellcome to");
	__POINTW2MN _0x140,0
	CALL SUBOPT_0x25
; 0000 0308 lcd_gotoxy(5,2);
; 0000 0309 lcd_puts("XO game!");
	__POINTW2MN _0x140,12
	RCALL _lcd_puts
; 0000 030A delay_ms(1500);
	LDI  R26,LOW(1500)
	LDI  R27,HIGH(1500)
	CALL _delay_ms
; 0000 030B lcd_clear();
	RCALL _lcd_clear
; 0000 030C delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 030D lcd_gotoxy(1,1);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x24
; 0000 030E lcd_puts("to start press");
	__POINTW2MN _0x140,21
	CALL SUBOPT_0x25
; 0000 030F lcd_gotoxy(5,2);
; 0000 0310 lcd_puts("any key");
	__POINTW2MN _0x140,36
	RCALL _lcd_puts
; 0000 0311 while(kelid==20)
_0x141:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CP   R30,R10
	CPC  R31,R11
	BRNE _0x143
; 0000 0312 {
; 0000 0313     kelid=kypad();
	RCALL _kypad
	MOVW R10,R30
; 0000 0314 }
	RJMP _0x141
_0x143:
; 0000 0315 kelid=20;
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	MOVW R10,R30
; 0000 0316 
; 0000 0317 
; 0000 0318 
; 0000 0319 
; 0000 031A 
; 0000 031B label:
_0x144:
; 0000 031C while (1)
; 0000 031D       {
; 0000 031E         int w;
; 0000 031F         lcd_clear();
	SBIW R28,2
;	w -> Y+0
	CALL SUBOPT_0x26
; 0000 0320         lcdshow();
; 0000 0321         lcd_gotoxy(6,0);
	CALL SUBOPT_0x27
; 0000 0322         sprintf(tabdil, "round=%d",round);
	CALL SUBOPT_0xC
	__POINTW1FN _0x0,53
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R12
	CALL SUBOPT_0xD
; 0000 0323         lcd_puts(tabdil);
	RCALL _lcd_puts
; 0000 0324         lcd_gotoxy(6,1);
	LDI  R30,LOW(6)
	CALL SUBOPT_0x24
; 0000 0325         sprintf(tabdil, "X_WIN=%d",bord_x);
	CALL SUBOPT_0xC
	CALL SUBOPT_0x28
; 0000 0326         lcd_puts(tabdil);
	CALL SUBOPT_0x29
; 0000 0327         lcd_gotoxy(6,2);
; 0000 0328         sprintf(tabdil, "O_WIN=%d",bord_o);
	CALL SUBOPT_0xC
	CALL SUBOPT_0x2A
; 0000 0329         lcd_puts(tabdil);
	RCALL _lcd_puts
; 0000 032A 
; 0000 032B 
; 0000 032C         for (w=0;w<9;w++)
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
_0x149:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,9
	BRLT PC+2
	RJMP _0x14A
; 0000 032D         {
; 0000 032E             valid=0;
	LDI  R30,LOW(0)
	STS  _valid,R30
	STS  _valid+1,R30
; 0000 032F             kelid=20;
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	MOVW R10,R30
; 0000 0330 
; 0000 0331             lcd_gotoxy(6,3);
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R26,LOW(3)
	RCALL _lcd_gotoxy
; 0000 0332             if(nobat==0)
	CALL SUBOPT_0x0
	BRNE _0x14B
; 0000 0333             {
; 0000 0334                 lcd_puts("X turn");
	__POINTW2MN _0x140,44
	RJMP _0x17D
; 0000 0335             }else{
_0x14B:
; 0000 0336                 lcd_puts("O turn");
	__POINTW2MN _0x140,51
_0x17D:
	RCALL _lcd_puts
; 0000 0337             }
; 0000 0338             PORTB= sevseg[nobat];
	LDS  R30,_nobat
	LDS  R31,_nobat+1
	LDI  R26,LOW(_sevseg)
	LDI  R27,HIGH(_sevseg)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	OUT  0x18,R30
; 0000 0339 
; 0000 033A             while(valid==0)
_0x14D:
	LDS  R30,_valid
	LDS  R31,_valid+1
	SBIW R30,0
	BRNE _0x14F
; 0000 033B             {
; 0000 033C                 kelid=kypad();
	RCALL _kypad
	MOVW R10,R30
; 0000 033D                 valid=movevalid(kelid);
	MOVW R26,R10
	RCALL _movevalid
	STS  _valid,R30
	STS  _valid+1,R31
; 0000 033E             }
	RJMP _0x14D
_0x14F:
; 0000 033F 
; 0000 0340             vazeyat= change(kelid);
	MOVW R26,R10
	RCALL _change
	STS  _vazeyat,R30
	STS  _vazeyat+1,R31
; 0000 0341             if (vazeyat==1)  {    //0=ok , 1= yeki borde
	LDS  R26,_vazeyat
	LDS  R27,_vazeyat+1
	SBIW R26,1
	BREQ PC+2
	RJMP _0x150
; 0000 0342                 lcd_clear();
	CALL SUBOPT_0x26
; 0000 0343                 lcdshow();
; 0000 0344                 delay_ms(50);
	CALL SUBOPT_0x2B
; 0000 0345                 lcd_gotoxy(6,0);
; 0000 0346                 if(nobat==0){
	CALL SUBOPT_0x0
	BRNE _0x151
; 0000 0347                     lcd_puts("X win");
	__POINTW2MN _0x140,58
	RCALL _lcd_puts
; 0000 0348                     bord_x++;
	LDI  R26,LOW(_bord_x)
	LDI  R27,HIGH(_bord_x)
	RJMP _0x17E
; 0000 0349                 }else if(nobat==1){
_0x151:
	LDS  R26,_nobat
	LDS  R27,_nobat+1
	SBIW R26,1
	BRNE _0x153
; 0000 034A                     lcd_puts("O win");
	__POINTW2MN _0x140,64
	RCALL _lcd_puts
; 0000 034B                     bord_o++;
	LDI  R26,LOW(_bord_o)
	LDI  R27,HIGH(_bord_o)
_0x17E:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 034C                 }
; 0000 034D                 lcd_gotoxy(6,1);
_0x153:
	LDI  R30,LOW(6)
	CALL SUBOPT_0x24
; 0000 034E                 lcd_puts("1=ply agin");
	__POINTW2MN _0x140,70
	CALL SUBOPT_0x29
; 0000 034F                 lcd_gotoxy(6,2);
; 0000 0350                 lcd_puts("2=EXIT");
	__POINTW2MN _0x140,81
	RCALL _lcd_puts
; 0000 0351                 while(1)
_0x154:
; 0000 0352                 {
; 0000 0353                     kelid=kypad();
	CALL SUBOPT_0x2C
; 0000 0354                     if (kelid==1){
	BRNE _0x157
; 0000 0355                         l3=0;
	CLR  R8
	CLR  R9
; 0000 0356                         for(l=0;l<3;l++){
	CLR  R4
	CLR  R5
_0x159:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R4,R30
	CPC  R5,R31
	BRGE _0x15A
; 0000 0357                             for(l1=0;l1<3;l1++){
	CLR  R6
	CLR  R7
_0x15C:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R6,R30
	CPC  R7,R31
	BRGE _0x15D
; 0000 0358                                 bord[l][l1]=l3;
	CALL SUBOPT_0x2D
; 0000 0359                                 l3++;
; 0000 035A                             }
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
	RJMP _0x15C
_0x15D:
; 0000 035B                         }
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	RJMP _0x159
_0x15A:
; 0000 035C                         round++;
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
; 0000 035D                         goto label;
	RJMP _0x144
; 0000 035E                     } else if(kelid==2){
_0x157:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CP   R30,R10
	CPC  R31,R11
	BRNE _0x15F
; 0000 035F                         goto label1;
	RJMP _0x160
; 0000 0360                     }
; 0000 0361                 }
_0x15F:
	RJMP _0x154
; 0000 0362                break;
; 0000 0363             }
; 0000 0364 
; 0000 0365             if(w==8){  //vaghti mosavi mishan
_0x150:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,8
	BRNE _0x161
; 0000 0366                 lcd_clear();
	CALL SUBOPT_0x26
; 0000 0367                 lcdshow();
; 0000 0368 
; 0000 0369                 delay_ms(50);
	CALL SUBOPT_0x2B
; 0000 036A                 lcd_gotoxy(6,0);
; 0000 036B                 lcd_puts("draw!");
	__POINTW2MN _0x140,88
	RCALL _lcd_puts
; 0000 036C                 lcd_gotoxy(6,1);
	LDI  R30,LOW(6)
	CALL SUBOPT_0x24
; 0000 036D                 lcd_puts("1=ply agin");
	__POINTW2MN _0x140,94
	CALL SUBOPT_0x29
; 0000 036E                 lcd_gotoxy(6,2);
; 0000 036F                 lcd_puts("2=EXIT");
	__POINTW2MN _0x140,105
	RCALL _lcd_puts
; 0000 0370                 while(1)
_0x162:
; 0000 0371                 {
; 0000 0372                     kelid=kypad();
	CALL SUBOPT_0x2C
; 0000 0373                     if (kelid==1){
	BRNE _0x165
; 0000 0374                         l3=0;
	CLR  R8
	CLR  R9
; 0000 0375                         for(l=0;l<3;l++){
	CLR  R4
	CLR  R5
_0x167:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R4,R30
	CPC  R5,R31
	BRGE _0x168
; 0000 0376                             for(l1=0;l1<3;l1++){
	CLR  R6
	CLR  R7
_0x16A:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R6,R30
	CPC  R7,R31
	BRGE _0x16B
; 0000 0377                                 bord[l][l1]=l3;
	CALL SUBOPT_0x2D
; 0000 0378                                 l3++;
; 0000 0379                             }
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
	RJMP _0x16A
_0x16B:
; 0000 037A                         }
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	RJMP _0x167
_0x168:
; 0000 037B                         round++;
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
; 0000 037C                         goto label;
	RJMP _0x144
; 0000 037D                     } else if(kelid==2){
_0x165:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CP   R30,R10
	CPC  R31,R11
	BREQ _0x160
; 0000 037E                         goto label1;
; 0000 037F                     }
; 0000 0380                 }
	RJMP _0x162
; 0000 0381 
; 0000 0382             }
; 0000 0383 
; 0000 0384             if(nobat==0) //taviz nibat
_0x161:
	CALL SUBOPT_0x0
	BRNE _0x16E
; 0000 0385             {
; 0000 0386                nobat=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _nobat,R30
	STS  _nobat+1,R31
; 0000 0387             }else{
	RJMP _0x16F
_0x16E:
; 0000 0388                 nobat=0;
	LDI  R30,LOW(0)
	STS  _nobat,R30
	STS  _nobat+1,R30
; 0000 0389             }
_0x16F:
; 0000 038A 
; 0000 038B 
; 0000 038C         }
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	RJMP _0x149
_0x14A:
; 0000 038D 
; 0000 038E         label1:
_0x160:
; 0000 038F         lcd_clear();
	RCALL _lcd_clear
; 0000 0390         lcd_gotoxy(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _lcd_gotoxy
; 0000 0391         if(bord_o>bord_x){
	CALL SUBOPT_0x2E
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x170
; 0000 0392             lcd_puts("congratulation o");
	__POINTW2MN _0x140,112
	RJMP _0x17F
; 0000 0393         }else if(bord_o<bord_x){
_0x170:
	CALL SUBOPT_0x2E
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x172
; 0000 0394             lcd_puts("congratulation x");
	__POINTW2MN _0x140,129
	RJMP _0x17F
; 0000 0395         } else{
_0x172:
; 0000 0396             lcd_gotoxy(5,0);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _lcd_gotoxy
; 0000 0397             lcd_puts("draw!");
	__POINTW2MN _0x140,146
_0x17F:
	RCALL _lcd_puts
; 0000 0398         }
; 0000 0399 
; 0000 039A         lcd_gotoxy(5,1);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x24
; 0000 039B         sprintf(tabdil, "X_WIN=%d",bord_x);
	CALL SUBOPT_0xC
	CALL SUBOPT_0x28
; 0000 039C         lcd_puts(tabdil);
	CALL SUBOPT_0x25
; 0000 039D         lcd_gotoxy(5,2);
; 0000 039E         sprintf(tabdil, "O_WIN=%d",bord_o);
	CALL SUBOPT_0xC
	CALL SUBOPT_0x2A
; 0000 039F         lcd_puts(tabdil);
	RCALL _lcd_puts
; 0000 03A0 
; 0000 03A1         break;
	ADIW R28,2
; 0000 03A2 
; 0000 03A3       }
; 0000 03A4 }
_0x174:
	RJMP _0x174
; .FEND

	.DSEG
_0x140:
	.BYTE 0x98
;
;
;
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
; .FSTART __lcd_write_nibble_G100
	ST   -Y,R26
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2000004
	SBI  0x1B,3
	RJMP _0x2000005
_0x2000004:
	CBI  0x1B,3
_0x2000005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	SBI  0x1B,4
	RJMP _0x2000007
_0x2000006:
	CBI  0x1B,4
_0x2000007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2000008
	SBI  0x1B,5
	RJMP _0x2000009
_0x2000008:
	CBI  0x1B,5
_0x2000009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x200000A
	SBI  0x1B,6
	RJMP _0x200000B
_0x200000A:
	CBI  0x1B,6
_0x200000B:
	__DELAY_USB 2
	SBI  0x1B,2
	__DELAY_USB 2
	CBI  0x1B,2
	__DELAY_USB 2
	RJMP _0x2080002
; .FEND
__lcd_write_data:
; .FSTART __lcd_write_data
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 17
	RJMP _0x2080002
; .FEND
_lcd_gotoxy:
; .FSTART _lcd_gotoxy
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
; .FEND
_lcd_clear:
; .FSTART _lcd_clear
	LDI  R26,LOW(2)
	CALL SUBOPT_0x2F
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	CALL SUBOPT_0x2F
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
; .FEND
_lcd_putchar:
; .FSTART _lcd_putchar
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2000010
_0x2000011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,__lcd_y
	SUBI R26,-LOW(1)
	STS  __lcd_y,R26
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2000013
	RJMP _0x2080002
_0x2000013:
_0x2000010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x1B,0
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x1B,0
	RJMP _0x2080002
; .FEND
_lcd_puts:
; .FSTART _lcd_puts
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2000014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000016
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2000014
_0x2000016:
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND
_lcd_init:
; .FSTART _lcd_init
	ST   -Y,R26
	SBI  0x1A,3
	SBI  0x1A,4
	SBI  0x1A,5
	SBI  0x1A,6
	SBI  0x1A,2
	SBI  0x1A,0
	SBI  0x1A,1
	CBI  0x1B,2
	CBI  0x1B,0
	CBI  0x1B,1
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R26,LOW(20)
	LDI  R27,0
	CALL _delay_ms
	CALL SUBOPT_0x30
	CALL SUBOPT_0x30
	CALL SUBOPT_0x30
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 33
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x2080002:
	ADIW R28,1
	RET
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G101:
; .FSTART _put_buff_G101
	CALL SUBOPT_0xE
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
_0x2020013:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2020014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2020014:
	RJMP _0x2020015
_0x2020010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
; .FEND
__print_G101:
; .FSTART __print_G101
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2020018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x202001C
	CPI  R18,37
	BRNE _0x202001D
	LDI  R17,LOW(1)
	RJMP _0x202001E
_0x202001D:
	CALL SUBOPT_0x31
_0x202001E:
	RJMP _0x202001B
_0x202001C:
	CPI  R30,LOW(0x1)
	BRNE _0x202001F
	CPI  R18,37
	BRNE _0x2020020
	CALL SUBOPT_0x31
	RJMP _0x20200CC
_0x2020020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020021
	LDI  R16,LOW(1)
	RJMP _0x202001B
_0x2020021:
	CPI  R18,43
	BRNE _0x2020022
	LDI  R20,LOW(43)
	RJMP _0x202001B
_0x2020022:
	CPI  R18,32
	BRNE _0x2020023
	LDI  R20,LOW(32)
	RJMP _0x202001B
_0x2020023:
	RJMP _0x2020024
_0x202001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2020025
_0x2020024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020026
	ORI  R16,LOW(128)
	RJMP _0x202001B
_0x2020026:
	RJMP _0x2020027
_0x2020025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x202001B
_0x2020027:
	CPI  R18,48
	BRLO _0x202002A
	CPI  R18,58
	BRLO _0x202002B
_0x202002A:
	RJMP _0x2020029
_0x202002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x202001B
_0x2020029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x202002F
	CALL SUBOPT_0x32
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x33
	RJMP _0x2020030
_0x202002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2020032
	CALL SUBOPT_0x32
	CALL SUBOPT_0x34
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2020033
_0x2020032:
	CPI  R30,LOW(0x70)
	BRNE _0x2020035
	CALL SUBOPT_0x32
	CALL SUBOPT_0x34
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x64)
	BREQ _0x2020039
	CPI  R30,LOW(0x69)
	BRNE _0x202003A
_0x2020039:
	ORI  R16,LOW(4)
	RJMP _0x202003B
_0x202003A:
	CPI  R30,LOW(0x75)
	BRNE _0x202003C
_0x202003B:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x202003D
_0x202003C:
	CPI  R30,LOW(0x58)
	BRNE _0x202003F
	ORI  R16,LOW(8)
	RJMP _0x2020040
_0x202003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2020071
_0x2020040:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x202003D:
	SBRS R16,2
	RJMP _0x2020042
	CALL SUBOPT_0x32
	CALL SUBOPT_0x35
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2020043:
	CPI  R20,0
	BREQ _0x2020044
	SUBI R17,-LOW(1)
	RJMP _0x2020045
_0x2020044:
	ANDI R16,LOW(251)
_0x2020045:
	RJMP _0x2020046
_0x2020042:
	CALL SUBOPT_0x32
	CALL SUBOPT_0x35
_0x2020046:
_0x2020036:
	SBRC R16,0
	RJMP _0x2020047
_0x2020048:
	CP   R17,R21
	BRSH _0x202004A
	SBRS R16,7
	RJMP _0x202004B
	SBRS R16,2
	RJMP _0x202004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004D
_0x202004C:
	LDI  R18,LOW(48)
_0x202004D:
	RJMP _0x202004E
_0x202004B:
	LDI  R18,LOW(32)
_0x202004E:
	CALL SUBOPT_0x31
	SUBI R21,LOW(1)
	RJMP _0x2020048
_0x202004A:
_0x2020047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x202004F
_0x2020050:
	CPI  R19,0
	BREQ _0x2020052
	SBRS R16,3
	RJMP _0x2020053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2020054
_0x2020053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2020054:
	CALL SUBOPT_0x31
	CPI  R21,0
	BREQ _0x2020055
	SUBI R21,LOW(1)
_0x2020055:
	SUBI R19,LOW(1)
	RJMP _0x2020050
_0x2020052:
	RJMP _0x2020056
_0x202004F:
_0x2020058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x202005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x202005A
_0x202005C:
	CPI  R18,58
	BRLO _0x202005D
	SBRS R16,3
	RJMP _0x202005E
	SUBI R18,-LOW(7)
	RJMP _0x202005F
_0x202005E:
	SUBI R18,-LOW(39)
_0x202005F:
_0x202005D:
	SBRC R16,4
	RJMP _0x2020061
	CPI  R18,49
	BRSH _0x2020063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020062
_0x2020063:
	RJMP _0x20200CD
_0x2020062:
	CP   R21,R19
	BRLO _0x2020067
	SBRS R16,0
	RJMP _0x2020068
_0x2020067:
	RJMP _0x2020066
_0x2020068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2020069
	LDI  R18,LOW(48)
_0x20200CD:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x202006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x33
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x202006A:
_0x2020069:
_0x2020061:
	CALL SUBOPT_0x31
	CPI  R21,0
	BREQ _0x202006C
	SUBI R21,LOW(1)
_0x202006C:
_0x2020066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020059
	RJMP _0x2020058
_0x2020059:
_0x2020056:
	SBRS R16,0
	RJMP _0x202006D
_0x202006E:
	CPI  R21,0
	BREQ _0x2020070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x33
	RJMP _0x202006E
_0x2020070:
_0x202006D:
_0x2020071:
_0x2020030:
_0x20200CC:
	LDI  R17,LOW(0)
_0x202001B:
	RJMP _0x2020016
_0x2020018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
; .FEND
_sprintf:
; .FSTART _sprintf
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x36
	SBIW R30,0
	BRNE _0x2020072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2080001
_0x2020072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x36
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2080001:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
; .FEND

	.CSEG

	.CSEG
_strlen:
; .FSTART _strlen
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
; .FEND
_strlenf:
; .FSTART _strlenf
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
; .FEND

	.DSEG
_sevseg:
	.BYTE 0x4
_bord:
	.BYTE 0x12
_tabdil:
	.BYTE 0x14
_bord_o:
	.BYTE 0x2
_bord_x:
	.BYTE 0x2
_nobat:
	.BYTE 0x2
_valid:
	.BYTE 0x2
_vazeyat:
	.BYTE 0x2
__base_y_G100:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x0:
	LDS  R30,_nobat
	LDS  R31,_nobat+1
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	MOVW R30,R18
	LDI  R26,LOW(_bord)
	LDI  R27,HIGH(_bord)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R30,R20
	CPC  R31,R21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x3:
	__GETWRN 20,21,0
	__GETWRN 18,19,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4:
	__POINTW2MN _bord,6
	MOVW R30,R18
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	__POINTW2MN _bord,12
	MOVW R30,R18
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 34 TIMES, CODE SIZE REDUCTION:96 WORDS
SUBOPT_0x6:
	__MULBNWRU 18,19,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	MOVW R26,R30
	CALL __GETW1P
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8:
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	MOVW R26,R30
	MOVW R30,R18
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x9:
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	MOVW R26,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	SUB  R30,R18
	SBC  R31,R19
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	MOVW R26,R30
	CALL __GETW1P
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0xB:
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	MOVW R26,R30
	MOVW R30,R16
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(_tabdil)
	LDI  R31,HIGH(_tabdil)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0xD:
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	LDI  R26,LOW(_tabdil)
	LDI  R27,HIGH(_tabdil)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xF:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDI  R26,LOW(_bord)
	LDI  R27,HIGH(_bord)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	CALL __GETW1P
	MOVW R26,R30
	SBIW R30,30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	MOVW R30,R26
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x12:
	__POINTW2MN _bord,6
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,3
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x13:
	__POINTW2MN _bord,12
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,6
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:87 WORDS
SUBOPT_0x14:
	CALL _lcdshow
	LDI  R26,LOW(250)
	LDI  R27,0
	CALL _delay_ms
	__GETWRN 18,19,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x15:
	MOVW R30,R18
	LDI  R26,LOW(_bord)
	LDI  R27,HIGH(_bord)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(35)
	LDI  R31,HIGH(35)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:87 WORDS
SUBOPT_0x17:
	CALL _lcdshow
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
	__GETWRN 18,19,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0x19:
	CALL _lcdshow
	LDI  R26,LOW(750)
	LDI  R27,HIGH(750)
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1A:
	__POINTW2MN _bord,6
	MOVW R30,R18
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1B:
	__POINTW2MN _bord,12
	MOVW R30,R18
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	LDI  R26,LOW(35)
	LDI  R27,HIGH(35)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDI  R26,LOW(30)
	LDI  R27,HIGH(30)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	__ADDW1MN _bord,2
	LDI  R26,LOW(35)
	LDI  R27,HIGH(35)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	__ADDW1MN _bord,4
	LDI  R26,LOW(35)
	LDI  R27,HIGH(35)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x20:
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	MOVW R26,R30
	MOVW R30,R18
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x21:
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	MOVW R26,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	SUB  R30,R18
	SBC  R31,R19
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	LDI  R26,LOW(40)
	LDI  R27,HIGH(40)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x24:
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x25:
	CALL _lcd_puts
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R26,LOW(2)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	CALL _lcd_clear
	JMP  _lcdshow

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x27:
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x28:
	__POINTW1FN _0x0,62
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_bord_x
	LDS  R31,_bord_x+1
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x29:
	CALL _lcd_puts
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R26,LOW(2)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2A:
	__POINTW1FN _0x0,71
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_bord_o
	LDS  R31,_bord_o+1
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	LDI  R26,LOW(50)
	LDI  R27,0
	CALL _delay_ms
	RJMP SUBOPT_0x27

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2C:
	CALL _kypad
	MOVW R10,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R10
	CPC  R31,R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x2D:
	MOVW R30,R4
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	CALL __MULW12U
	SUBI R30,LOW(-_bord)
	SBCI R31,HIGH(-_bord)
	MOVW R26,R30
	MOVW R30,R6
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R8
	STD  Z+1,R9
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2E:
	LDS  R30,_bord_x
	LDS  R31,_bord_x+1
	LDS  R26,_bord_o
	LDS  R27,_bord_o+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2F:
	CALL __lcd_write_data
	LDI  R26,LOW(3)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x30:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G100
	__DELAY_USB 33
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x31:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x32:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x34:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x35:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x36:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	wdr
	__DELAY_USW 0xFA
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
